;
;   NICE BACKGROUND
;
;   Compile with FASM for Menuet
;

;******************************************************************************
    use32
    org    0x0

    db     'MENUET01'      ; 8 byte id
    dd     0x01            ; header version
    dd     START           ; start of code
    dd     I_END           ; size of image
    dd     0x20000         ; memory for app
    dd     0x20000         ; esp
    dd     0x0 , 0x0       ; I_Param , I_Icon

include    "MACROS.INC"
;******************************************************************************

GRADES       =    100         ; count of grades
START_COLOR  =    0x8292B4      ;0x0078b000
STEP         =    0x010101      ;0x00010100
xxx          equ  sub         ; from dark to light

;******************************************************************************

db "This program is taken from RE7 distro!",13,10

defcol       db 'NEWSKIN.DTP'  ;'GREEN.DTP'
jpegview     db 'JPEGVIEW   '
boot         db 'BOOT',0

START:

mov eax,6           ; open system colors file
mov ebx,defcol
mov ecx,0
mov edx,-1
mov esi,0x10000
int 0x40

mov eax,48          ; set system colors
mov ebx,2
mov ecx,0x10000
mov edx,10*4
int 0x40

mov eax,15          ; set stretch backgound
mov ebx,4
mov ecx,2
int 0x40

mov eax, 19         ; set wallpaper from JPEGVIEW.JPG
mov ebx, jpegview
mov ecx, boot
int 0x40

jmp exit

mov eax,image+3     ; generate image
mov ecx,GRADES-1
@@:
mov ebx,[eax-3]
xxx ebx,STEP
mov [eax],ebx
add eax,3
dec ecx
jnz @b

mov eax,15          ; copy image to background memory
mov ebx,5
mov ecx,image
xor edx,edx
mov esi,(GRADES+1)*3
int 0x40

mov eax,15          ; set stretch backgound
mov ebx,4
mov ecx,2
int 0x40

mov eax,15          ; set background size
mov ebx,1
mov ecx,ebx
mov edx,GRADES
int 0x40

mov eax,15          ; draw background
mov ebx,3
int 0x40

exit:

; BEGIN_REDRAW_SCREEN
   mov  eax, 12
   mov  ebx, 1
   int  0x40

   mov  eax, 14
   int  0x40
   mov  ecx, eax
   shr  eax, 16
   and  ecx, 0xFFFF
   mov  ebx, eax
   mov  eax, 0
   mov  edx, 0x01000000
   int  0x40

   mov  eax, 12
   mov  ebx, 2
   int  0x40
; END_REDRAW_SCREEN

or  eax,-1
int 0x40



image:
dd START_COLOR

I_END:
; EOF